﻿Type=Service
Version=2.5
@EndOfDesignText@
#Region Module Attributes
	#StartAtBoot: False
#End Region

'Service module
Sub Process_Globals
	Dim lwm As LWManager
	Dim LiveEngine As LWEngine

	Dim tick As Int 
	Dim x1,y1 As Int 
	
	Dim RGBRed, RGBGreen, RGBBlue, ArgbAlpha As Int
	Dim maxomur,dalgasayisi  As Int  
	Dim yagmurgoster,yagmuryagsin,dalgalardolsun,Yon,elleyaratilanvar As Boolean   
	Dim counter,counter1,counter2, dalgacapi,dalgacapiartisi,idlecounter,cizgikalinligicarpani,idlecounterfark,idlebeklemezamani As Int 

	Dim yagmurkalinligi,cizgikalinligi As Float
	Dim dalgaadedicounter,tickomruazalis As Int
	Dim DalgaSekli,rotation,rotationincrease As Int
	Dim SquareRect As Rect

	rotation				= 0
	rotationincrease		= 0
	dalgaadedicounter		= 0			' number of shapes   			-	şekil sayısı
	Yon						= True		' FF - REW						-	ileri - geri
	yagmurgoster			= False		' show drops					-	yagmur damlaları görünsünmü
	yagmuryagsin			= False		' ....							-	ekrana dokununca en son yagmur damlasını silmek için 
	dalgalardolsun			= False		' fill							- 
	elleyaratilanvar		= False		' handmade
	yagmurkalinligi 		= 0.1		' thickness of drops
	dalgacapi				= 3			' start radius					-	dairelerin baslangıc capları
	cizgikalinligi 			= 3 		' line thickness				-	daire cızgılerinin kalınlıgı
	dalgacapiartisi 		= 1			' radius increase				-	dairelerin caplarının buyume hızı

	tickomruazalis			= 1			' aging							-	yaslanma
	idlecounter 			= 0			' counter						-	sayac
	cizgikalinligicarpani 	= 4			' linethicknessfactor			-	cizgilerin kalından inceye gidis hızları
	idlecounterfark			= 2         ' time between random shapes	-	rastegle dairelerin olusma sıklığı
	idlebeklemezamani 		= 10      	' start time of random shapes	-	rastgele dairelerin olusmaya baslama zamanı
	DalgaSekli				= 1			'' 1-circle ,2-Square, 3-Oval, 4-line, 5-Path?, 6-Text?
	ArgbAlpha 				= 255		' background color				-	ekran arka plan rengi
	RGBRed					= 0
	RGBGreen				= 0
	RGBBlue 				= 0
	
	'Performance related variables
	
	tick 					= 50		' screen update					-	ekran update aralıgı - ms
	maxomur 				= 60		' life of shapes				-	dairelerin tick olarak ömrü  - rastege de random yapıldı
	dalgasayisi 			= 200		' max shape count				-	ekrandaki max daire sayısı  maxomur e baglı olarak max (maxomur-1) oluyor
	
	Dim dalgalar(dalgasayisi,13) As Float  	' dalgalar(0-dalgasayısı,1-X,2-Y,3-cap,4-tickomuru,5-visible,6-R,7-G,8-B,9-cizgikalinligi,10-rotation,11-elleyaratıldı)
	
End Sub

Sub LWM_Touch (Engine As LWEngine, Action As Int, X As Float, Y As Float)
idlecounter		= 0
yagmuryagsin 	= False
If Action=0 OR Action = 2  Then
	For counter = 1 To dalgasayisi -1
		If dalgalar(counter,5) = 0 Then	
			dalgalar(counter,1) 	= X
			dalgalar(counter,2) 	= Y
			dalgalar(counter,3) 	= dalgacapi
			dalgalar(counter,4) 	= maxomur
			dalgalar(counter,5) 	= 1
			dalgalar(counter,6) 	= Rnd(0,255)
			dalgalar(counter,7) 	= Rnd(0,255)
			dalgalar(counter,8) 	= Rnd(0,255)
			dalgalar(counter,9) 	= cizgikalinligi
			dalgalar(counter,10)	= rotation	
			dalgalar(counter,11)	= 1	
			dalgaadedicounter = dalgaadedicounter + 1
			Exit
		Else
		End If
	Next
Else 
End If

End Sub
Sub Service_Create
	lwm.Initialize("lwm", True)
	SquareRect.Initialize(0,0,0,0)
	lwm.StartTicking(tick)
End Sub
Sub Service_Start (StartingIntent As Intent)
End Sub
Sub Service_Destroy
End Sub

Sub RastgeleYarat(Engine As LWEngine)
' dalgalar(0-dalgasayısı,1-X,2-Y,3-cap,4-tickomuru,5-visible,6-R,7-G,8-B,9-cizgikalinligi,10-rotation,11-elleyaratıldı)
For counter = 1 To dalgasayisi -1
	If dalgalar(counter,5) = 0 Then	
		dalgalar(counter,1)		= Rnd(0,Engine.ScreenWidth)
		dalgalar(counter,2) 	= Rnd(0,Engine.ScreenHeight)
		dalgalar(counter,3) 	= dalgacapi
		dalgalar(counter,4) 	= Rnd(5,maxomur)
		dalgalar(counter,5) 	= 1
		dalgalar(counter,6) 	= Rnd(0,255)
		dalgalar(counter,7) 	= Rnd(0,255)
		dalgalar(counter,8) 	= Rnd(0,255)
		dalgalar(counter,9) 	= cizgikalinligi
		dalgalar(counter,10)	= Rnd(0,255)
		dalgalar(counter,11)	= 0
		dalgaadedicounter = dalgaadedicounter + 1
		x1 = dalgalar(counter,1)
		y1 = dalgalar(counter,2)
		Exit
	Else
	End If
Next
End Sub

Sub LWM_Tick (Engine As LWEngine)
rotation	= rotation		+ rotationincrease
If  elleyaratilanvar = False Then 
'	idlecounter = idlecounter   + 1
'	If idlecounter = idlebeklemezamani Then
'		idlecounter = idlecounter - idlecounterfark
		yagmuryagsin = True
		RastgeleYarat(Engine)
'	Else
'	End If
Else
End If

Engine.Canvas.DrawColor(Colors.ARGB(ArgbAlpha,RGBRed,RGBBlue,RGBGreen))
' dalgalar(0-dalgasayısı,1-X,2-Y,3-cap,4-tickomuru,5-visible,6-R,7-G,8-B,9-cizgikalinligi,10-rotation)
elleyaratilanvar = False
For counter = 1 To dalgasayisi - 1
	If dalgalar(counter,5) = 1 Then		
		If Yon = True Then
				dalgalar(counter,3) = dalgalar(counter,3) + dalgacapiartisi
		Else
				dalgalar(counter,3) = dalgacapiartisi	*	dalgalar(counter,4)

		End If

		' 1-circle ,2-Square, 3-Oval, 4-line, 5-Path?, 6-Text?
		Select DalgaSekli
			Case	1
				Engine.Canvas.DrawCircle(dalgalar(counter,1),dalgalar(counter,2),dalgalar(counter,3),Colors.RGB(dalgalar(counter,6),dalgalar(counter,7),dalgalar(counter,8)),dalgalardolsun,dalgalar(counter,9))		
			Case	2
				SquareRect.Left 	= dalgalar(counter,1)	-	dalgalar(counter,3)
				SquareRect.Top		= dalgalar(counter,2)	-	dalgalar(counter,3)
				SquareRect.Right	= dalgalar(counter,1)	+	dalgalar(counter,3)
				SquareRect.Bottom	= dalgalar(counter,2)	+	dalgalar(counter,3)
				Engine.Canvas.DrawRectRotated(SquareRect,Colors.RGB(dalgalar(counter,6),dalgalar(counter,7),dalgalar(counter,8)),dalgalardolsun,dalgalar(counter,9),dalgalar(counter,10))	
			Case	3
				SquareRect.Left 	= dalgalar(counter,1)	-	dalgalar(counter,3)	*	2
				SquareRect.Top		= dalgalar(counter,2)	-	dalgalar(counter,3)
				SquareRect.Right	= dalgalar(counter,1)	+	dalgalar(counter,3)	*	2
				SquareRect.Bottom	= dalgalar(counter,2)	+	dalgalar(counter,3)
				Engine.Canvas.DrawOvalRotated(SquareRect,Colors.RGB(dalgalar(counter,6),dalgalar(counter,7),dalgalar(counter,8)),dalgalardolsun,dalgalar(counter,9),dalgalar(counter,10))
			Case	4
				Engine.Canvas.DrawLine((dalgalar(counter,1)-dalgalar(counter,3)*2),dalgalar(counter,2),(dalgalar(counter,1)+dalgalar(counter,3)*2),dalgalar(counter,2),Colors.RGB(dalgalar(counter,6),dalgalar(counter,7),dalgalar(counter,8)),dalgalar(counter,9))
		End Select

		dalgalar(counter,10)= dalgalar(counter,10) + rotationincrease * Rnd(0,5)
		dalgalar(counter,9) = (dalgalar(counter,4)/10) /  (maxomur/10)
		dalgalar(counter,9) = dalgalar(counter,9) * cizgikalinligicarpani
		dalgalar(counter,4) = dalgalar(counter,4) - tickomruazalis
		If dalgalar(counter,4)  < 0 Then 
			dalgalar(counter,5) = 0
			dalgalar(counter,11) = 0
			dalgaadedicounter = dalgaadedicounter - 1
		Else
		End If
		
		If dalgalar(counter,11) = 1 Then
			elleyaratilanvar = True
			idlecounter		= 0
		Else
		End If
		
	Else
	End If

Next
If yagmuryagsin AND yagmurgoster Then Engine.Canvas.DrawLine(x1,y1,x1-800,y1-4000,Colors.White,yagmurkalinligi)
Engine.RefreshAll
End Sub

Sub DalgalariSifirla
' dalgalar(0-dalgasayısı,1-X,2-Y,3-cap,4-tickomuru,5-visible,6-R,7-G,8-B,9-cizgikalinligi,10-rotation)
For counter = 1 To dalgasayisi -1
	For counter1 = 1 To 11
		dalgalar(counter,counter1) = 0
	Next
Next
End Sub


Sub ParametreDegisti
	lwm.StartTicking(tick)
	DalgalariSifirla
End Sub
